Rust Search

Find the best content on Rust, curated by the community; a search engine for Rustaceans.
github.com
## Summary [summary]: #summary Enable the compiler to select whether a target dynamically or statically links to a platform's standard C runtime ("CRT") through the introduction of three orthogonal and otherwise general purpose features, on...
RFC 1721 RFC 2016-08-18 ~12 min read
github.com
## Summary [summary]: #summary Make compiler aware of the association between library names adorning `extern` blocks and symbols defined within the block. Add attributes and command line switches that leverage this association. ## Motivatio...
RFC 1717 RFC 2016-08-13 ~4 min read
github.com
## Summary [summary]: #summary Better ergonomics for pattern-matching on references. Currently, matching on references requires a bit of a dance using `ref` and `&` patterns: ```rust let x: &Option<_> = &Some(0); match x { &Some(ref y) => {...
RFC 2005 RFC 2016-08-12 ~12 min read
github.com
## Summary [summary]: #summary A refinement of the Rust planning and reporting process, to establish a shared vision of the project among contributors, to make clear the roadmap toward that vision, and to celebrate our achievements. Rust's...
RFC 1728 RFC 2016-08-07 ~19 min read
github.com
## Summary [summary]: #summary This RFC proposes adding a new macro to `libcore`, `compile_error!` which will unconditionally cause compilation to fail with the given error message when encountered. ## Motivation [motivation]: #motivation C...
RFC 1695 RFC 2016-08-01 ~1 min read
github.com
## Summary [summary]: #summary Add a function that extracts the discriminant from an enum variant as a comparable, hashable, printable, but (for now) opaque and unorderable type. ## Motivation [motivation]: #motivation When using an ADT enu...
RFC 1696 RFC 2016-08-01 ~4 min read
github.com
## Summary [summary]: #summary `assert_ne` is a macro that takes 2 arguments and panics if they are equal. It works and is implemented identically to `assert_eq` and serves as its complement. This proposal also includes a `debug_asset_ne`,...
RFC 1653 RFC 2016-07-27 ~1 min read
github.com
## Summary [summary]: #summary Create a team responsible for documentation for the Rust project. ## Motivation [motivation]: #motivation [RFC 1068] introduced a federated governance model for the Rust project. Several initial subteams were...
RFC 1683 RFC 2016-07-21 ~4 min read
github.com
## Summary [summary]: #summary Currently Rust allows anonymous parameters in trait methods: ```Rust trait T { fn foo(i32); fn bar_with_default_impl(String, String) { } } ``` This RFC proposes to deprecate this syntax. This RFC intentionally...
RFC 1685 RFC 2016-07-19 ~4 min read
github.com
## Summary [summary]: #summary When initializing a data structure (struct, enum, union) with named fields, allow writing `fieldname` as a shorthand for `fieldname: fieldname`. This allows a compact syntax for initialization, with less dupli...
RFC 1682 RFC 2016-07-18 ~6 min read
github.com
## Summary [summary]: #summary Extract a very small sliver of today's procedural macro system in the compiler, just enough to get basic features like custom derive working, to have an eventually stable API. Ensure that these features will n...
RFC 1681 RFC 2016-07-14 ~19 min read
github.com
## Summary [summary]: #summary Rust programs compiled for Windows will always allocate a console window on startup. This behavior is controlled via the `SUBSYSTEM` parameter passed to the linker, and so *can* be overridden with specific com...
RFC 1665 RFC 2016-07-03 ~4 min read
github.com
## Summary [summary]: #summary Introduce non-panicking borrow methods on `RefCell<T>`. ## Motivation [motivation]: #motivation Whenever something is built from user input, for example a graph in which nodes are `RefCell<T>` values, it is pr...
RFC 1660 RFC 2016-06-27 ~1 min read
github.com
## Summary [summary]: #summary This RFC adds the following methods to atomic types: ```rust impl AtomicT { fn get_mut(&mut self) -> &mut T; fn into_inner(self) -> T; } ``` It also specifies that the layout of an `AtomicT` type is always the...
RFC 1649 RFC 2016-06-15 ~2 min read
github.com
## Summary [summary]: #summary Extend `Cell` to work with non-`Copy` types. ## Motivation [motivation]: #motivation It allows safe inner-mutability of non-`Copy` types without the overhead of `RefCell`'s reference counting. The key idea of...
RFC 1651 RFC 2016-06-15 ~1 min read
github.com
## Summary [summary]: #summary This RFC proposes allowing the `Self` type to be used in every position in trait implementations, including where clauses and other parameters to the trait being implemented. ## Motivation [motivation]: #motiv...
RFC 1647 RFC 2016-06-13 ~1 min read
github.com
## Summary [summary]: #summary Incorporate a strike team dedicated to preparing rules and guidelines for writing unsafe code in Rust (commonly referred to as Rust's "memory model"), in cooperation with the lang team. The discussion will gen...
RFC 1643 RFC 2016-06-07 ~11 min read
github.com
## Summary This RFC proposes an update to error reporting in rustc. Its focus is to change the format of Rust error messages and improve --explain capabilities to focus on the user's code. The end goal is for errors and explain text to be m...
RFC 1644 RFC 2016-06-07 ~13 min read
github.com
## Summary [summary]: #summary This RFC adds the `checked_*` methods already known from primitives like `usize` to `Duration`. ## Motivation [motivation]: #motivation Generally this helps when subtracting `Duration`s which can be the case q...
RFC 1640 RFC 2016-06-04 ~1 min read
github.com
## Summary One of the major goals of Rust's development process is *stability without stagnation*. That means we add features regularly. However, it can be difficult to *use* those features if they are not publicly documented anywhere. Ther...
RFC 1636 RFC 2016-06-03 ~16 min read
"On the topic of reframing UB, I was reminded of an article about the [mechanics of oaths and vows in historical cultures](https://acoup.blog/2019/06/2..."

Search tips

Type anything to search across articles, videos (including conference talks), podcasts, research, crates, and Rust API documentation. These operators give you finer control — click an example to try it.

Find pages containing all your words. Pages where the words appear together rank higher.
Quote part of your query to keep those words together as an exact phrase within a larger search.
Wrap the whole query in quotes for a verbatim search that matches text exactly, punctuation and all — perfect for Rust syntax. Needs at least 3 characters.
Put ! first to open the top result immediately. Quote the whole query for a literal leading bang, as in '!Send'. Bangs elsewhere, such as println!, stay literal. Browser and launcher shortcuts can invoke this directly. See search integrations.
Limit results to a single site. Works on its own () too. One site: per search.

Use the tabs and filters above the results to narrow by content type, publication year, and sort order.